package com.hotwj.platform.securityManagement.trainingOutlineCourse.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.securityManagement.trainingOutlineCourse.domain.HotTrainingOutlineCourse;
import com.hotwj.platform.securityManagement.trainingOutlineCourse.domain.bo.HotTrainingOutlineCourseBo;
import com.hotwj.platform.securityManagement.trainingOutlineCourse.domain.vo.HotTrainingOutlineCourseVo;
import com.hotwj.platform.securityManagement.trainingOutlineCourse.mapper.HotTrainingOutlineCourseMapper;
import com.hotwj.platform.securityManagement.trainingOutlineCourse.service.IHotTrainingOutlineCourseService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 培训大纲-课程大纲Service业务层处理
 *
 * @author shihongwei
 * @date 2026-01-14
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotTrainingOutlineCourseServiceImpl implements IHotTrainingOutlineCourseService {

    private final HotTrainingOutlineCourseMapper baseMapper;

    /**
     * 查询培训大纲-课程大纲
     *
     * @param id 主键
     * @return 培训大纲-课程大纲
     */
    @Override
    public HotTrainingOutlineCourseVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询培训大纲-课程大纲列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 培训大纲-课程大纲分页列表
     */
    @Override
    public TableDataInfo<HotTrainingOutlineCourseVo> queryPageList(HotTrainingOutlineCourseBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotTrainingOutlineCourse> lqw = buildQueryWrapper(bo);
        Page<HotTrainingOutlineCourseVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的培训大纲-课程大纲列表
     *
     * @param bo 查询条件
     * @return 培训大纲-课程大纲列表
     */
    @Override
    public List<HotTrainingOutlineCourseVo> queryList(HotTrainingOutlineCourseBo bo) {
        LambdaQueryWrapper<HotTrainingOutlineCourse> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotTrainingOutlineCourse> buildQueryWrapper(HotTrainingOutlineCourseBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotTrainingOutlineCourse> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotTrainingOutlineCourse::getId);
        lqw.eq(bo.getMonthOutlineId() != null, HotTrainingOutlineCourse::getMonthOutlineId, bo.getMonthOutlineId());
        lqw.eq(bo.getSortNo() != null, HotTrainingOutlineCourse::getSortNo, bo.getSortNo());
        lqw.like(StringUtils.isNotBlank(bo.getCourseName()), HotTrainingOutlineCourse::getCourseName, bo.getCourseName());
        lqw.eq(StringUtils.isNotBlank(bo.getBelongCourseId()), HotTrainingOutlineCourse::getBelongCourseId, bo.getBelongCourseId());
        lqw.eq(StringUtils.isNotBlank(bo.getCourseDesc()), HotTrainingOutlineCourse::getCourseDesc, bo.getCourseDesc());
        lqw.eq(bo.getDurationMinute() != null, HotTrainingOutlineCourse::getDurationMinute, bo.getDurationMinute());
        lqw.eq(bo.getIsDeleted() != null, HotTrainingOutlineCourse::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增培训大纲-课程大纲
     *
     * @param bo 培训大纲-课程大纲
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotTrainingOutlineCourseBo bo) {
        HotTrainingOutlineCourse add = MapstructUtils.convert(bo, HotTrainingOutlineCourse.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改培训大纲-课程大纲
     *
     * @param bo 培训大纲-课程大纲
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotTrainingOutlineCourseBo bo) {
        HotTrainingOutlineCourse update = MapstructUtils.convert(bo, HotTrainingOutlineCourse.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotTrainingOutlineCourse entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除培训大纲-课程大纲信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
